//  Wϊp@include t@C
#include <Windows.h>
#include "stdlib.h"
#include "math.h"
#include "stdarg.h"
#define LMAX 500
#define PI   3.14159265358979
typedef struct{
	double mat[4][4];
} TMatrix;
typedef struct{
	double X,Y,Z;
} Point;
typedef struct 
{
	int n;
	Point p[LMAX];
} Line;
typedef struct 
{
	int n;
	Point p[LMAX+1];
} Poly;

//----------------------------------------------------------------------
//Point֘A֐
Point setPoint(double X,double Y, double Z){
	Point p; p.X=X;p.Y=Y; p.Z=Z; return p;
}
Point setPoint(double X,double Y){
	Point p; p.X=X;p.Y=Y; p.Z=1; return p;
}
Point setPoint(){
	Point p; p.X=0;p.Y=0; p.Z=0; return p;
}
Point add   (Point a,Point b ){return setPoint(a.X+b.X, a.Y+b.Y, a.Z+b.Z);}
Point sub   (Point a,Point b ){return setPoint(a.X-b.X, a.Y-b.Y, a.Z-b.Z);}
Point minus (Point a         ){return setPoint(   -a.X,    -a.Y,    -a.Z);}
Point mlt   (double a,Point b){return setPoint(  a*b.X,   a*b.Y,   a*b.Z);}
Point mlt   (Point a,double b){return setPoint(  a.X*b,   a.Y*b,   a.Z*b);}
Point div   (Point a,double b){return setPoint(  a.X/b,   a.Y/b,   a.Z/b);}
double mlt  (Point a,Point b ){return a.X*b.X+ a.Y*b.Y+ a.Z*b.Z;}//
Point extmlt(Point a,Point b){                                   //O 
	return setPoint(a.Y*b.Z-a.Z*b.Y, a.Z*b.X-a.X*b.Z, a.X*b.Y-a.Y*b.X);
}
bool equal(Point a, Point b){ return a.X==b.X && a.Y==b.Y && a.Z==b.Z;}
bool notequal(Point a, Point b){ return !equal(a,b) ;}
double len(Point a){ return (double)sqrt(a.X*a.X+a.Y*a.Y+a.Z*a.Z);}
Point unit(Point a){ return (len(a)==0)? setPoint(1,0,0):div(a, len(a));}
Point unit(double a, double e){// XƂ̊pxa,XYʂƂ̊pxe̒PʃxNg
	double PIR=PI/180, aa=a*PIR, ee=e*PIR;// x(degree)fBA(radian)ɕϊ
	double X=cos(aa)*cos(ee), Y=sin(aa)*cos(ee), Z=sin(ee);
	return setPoint(X,Y,Z);
}
Point unit(double a)	{// Z=0, XƂ̊pxa̒PʃxNg
	double PIR = PI/180, aa=a*PIR;// x(degree)fBA(radian)ɕϊ
	double X=cos(aa), Y=sin(aa), Z=0;
	return setPoint(X,Y,Z);
}
//---------------------------------------------------------------------------------------
//Line֘A֐
Line setLine(int N){
	if(N>LMAX){
		TCHAR str[256];
		wsprintf(str,TEXT("**Error p`̒_ő %d 𒴂܂ N = %d"),
								LMAX+1,N);
		MessageBox(NULL,str, TEXT("my3Dmat"), MB_OK);
		N=LMAX;
	}
	Line L; L.n=N;	return L;
}
Line setLine(int N, Point P0, ...){
	Line L=setLine(N); L.p[0]=P0; va_list ap; va_start(ap, P0);
	for(int i=1; i<N; i++) L.p[i]=va_arg(ap, Point);
	va_end(ap);	return L;
}
Line setLine(Point P0, Point P1){return setLine(2,P0,P1);}
Line setLine(Point P0, Point P1, Point P2){ return setLine(3, P0, P1, P2);}
Line setLine(Point P0,Point P1,Point P2,Point P3){ return setLine(4, P0, P1, P2, P3);}
Line setLine(Point P0,Point P1,Point P2,Point P3, Point P4)
{ return setLine(5, P0, P1, P2, P3, P4);}
Line setLine(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5)
{ return setLine(6, P0, P1, P2, P3, P4, P5);}
Line setLine(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5,Point P6)
{ return setLine(7, P0, P1, P2, P3, P4, P5,P6);}
Line setLine(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5,Point P6,Point P7)
{ return setLine(8, P0, P1, P2, P3, P4, P5,P6,P7);}
Line setLine(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5,Point P6,Point P7,Point P8)
{ return setLine(9, P0, P1, P2, P3, P4, P5,P6,P7,P8);}
Line setLine(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5,Point P6,Point P7,Point P8,Point P9)
{ return setLine(10, P0, P1, P2, P3, P4, P5,P6,P7,P8, P9);}
Line setLine(Line b){ Line L=setLine(b.n);if(b.n>0) for(int i=0;i<b.n;i++)L.p[i]=b.p[i];return L;}
Line mlt(double a,Line b){
	Line C=setLine(b); for(int i=0;i<C.n;i++) {C.p[i].X *=a;C.p[i].Y *=a;C.p[i].Z *=a;}
	return C;
}
double len(Line a){
	double LN=0; for(int i=0;i<a.n-1;i++) LN += len(sub(a.p[i],a.p[i+1]));
	return LN;
}
Line circle_xz(int n, double b, double e){// XZʂ̒Pʔa̐^WiJnpx b, Ipx ej
	Line c = setLine(n+1); double PIR = PI/180, TH = b*PIR, DTH = PIR*(e-b)/n;
	for(int i=0; i<n+1;i++,TH+=DTH) c.p[i]=setPoint(sin(TH), 0.0, cos(TH));
	return c;
}
Line circle_xz(int n){return circle_xz(n,0,360);}// XZʂ̒Pʔả~`W
Line circle_yz(int n, double b, double e){// YZʂ̒Pʔa̐^WiJnpx b, Ipx ej
	Line c = setLine(n+1); double PIR = PI/180, TH = b*PIR, DTH = PIR*(e-b)/n;
	for(int i=0; i<n+1;i++,TH+=DTH) c.p[i]=setPoint(0.0, cos(TH), sin(TH));
	return c;
}
Line circle_yz(int n){return circle_yz(n,0,360);}// YZʂ̒Pʔả~`W
Line circle_xy(int n, double b, double e){// XYʂ̒Pʔa̐^WiJnpx b, Ipx ej
	Line c = setLine(n+1);double PIR = PI/180, TH=b*PIR, DTH=PIR*(e-b)/n;
	for(int i=0; i<n+1;i++,TH+=DTH) c.p[i]=setPoint(cos(TH),sin(TH),0);
	return c;
}
Line circle_xy(int n){return circle_xy(n,0,360);}// YZʂ̒Pʔả~`W
//---------------------------------------------------------------------------------------
//Poly֘A֐
Poly setPoly(int N){
	if(N>LMAX+1){
		TCHAR str[256];
		wsprintf(str,TEXT("**Error p`̒_ő %d 𒴂܂ N = %d"),
								LMAX+1,N);
		MessageBox(NULL,str,TEXT("my3Dmat"), MB_OK);
		N=LMAX+1;
	}
	Poly L; L.n=N;	return L;
}
Poly setPoly(int N, Point P0, ...){
	Poly P=setPoly(N + 1); P.p[0]=P0; va_list ap; va_start(ap, P0);
	for(int i=1; i<N; i++) P.p[i]=va_arg(ap, Point);
	P.p[N] = P0; va_end(ap); return P;
}
Poly setPoly(Point P0, Point P1, Point P2){ return setPoly(3, P0,P1,P2);}
Poly setPoly(Point P0,Point P1,Point P2,Point P3)
{ return setPoly(4, P0, P1, P2, P3);}
Poly setPoly(Point P0,Point P1,Point P2,Point P3, Point P4)
{ return setPoly(5, P0, P1, P2, P3, P4);}
Poly setPoly(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5)
{ return setPoly(6, P0,P1,P2, P3, P4, P5);}
Poly setPoly(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5,Point P6)
{ return setPoly(7, P0,P1,P2, P3, P4, P5,P6);}
Poly setPoly(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5,Point P6,Point P7)
{ return setPoly(8, P0,P1,P2, P3, P4, P5,P6, P7);}
Poly setPoly(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5,Point P6,Point P7,Point P8)
{ return setPoly(9, P0,P1,P2, P3, P4, P5,P6, P7,P8);}
Poly setPoly(Point P0,Point P1,Point P2,Point P3,Point P4,Point P5,Point P6,Point P7,Point P8,Point P9)
{ return setPoly(10, P0,P1,P2, P3, P4, P5,P6, P7,P8, P9);}
Poly setPoly(Point a[],int N){ 
	Poly p=setPoly(N+1);
	if(p.n>0) for(int i=0;i<p.n;i++)p.p[i]=a[i];p.p[p.n-1]=a[0]; 
	return p;
}
Poly setPoly(Line a){
	Poly p; p.n=a.n; if(a.n==0) return p;
	for(int i=0;i<a.n;i++)p.p[i]=a.p[i];
	if(notequal(a.p[0],a.p[a.n-1])){ p.n = a.n+1; p.p[a.n]=a.p[0];}
	return p;
}
Poly setPoly(Poly b){
	Poly p=setPoly(b.n); if(b.n>0) for(int i=0;i<b.n;i++)p.p[i]=b.p[i]; return p;
}
//----------------------------------------------------------------------
//TMatrix֘A֐
TMatrix setTMatrix(){
	TMatrix r;
	for(int i=0;i<4;i++)for(int j=0;j<4;j++)r.mat[i][j]=0;
	for(int i=0;i<4;i++)r.mat[i][i]=1;
	return r;
}
TMatrix setTMatrix(	 double D11, double D12, double D13,
					 double D21, double D22, double D23,
					 double D31, double D32, double D33){
	TMatrix r;
	r.mat[0][0]=D11;r.mat[0][1]=D12;r.mat[0][2]=D13;
	r.mat[1][0]=D21;r.mat[1][1]=D22;r.mat[1][2]=D23;
	r.mat[2][0]=D31;r.mat[2][1]=D32;r.mat[2][2]=D33;
	return r;
}
TMatrix setTMatrix(	double D11, double D12, double D13, double D14,
					double D21, double D22, double D23, double D24,
					double D31, double D32, double D33, double D34,
					double D41, double D42, double D43, double D44)
{
	TMatrix r;
	r.mat[0][0]=D11;r.mat[0][1]=D12;r.mat[0][2]=D13;r.mat[0][3]=D14;
	r.mat[1][0]=D21;r.mat[1][1]=D22;r.mat[1][2]=D23;r.mat[1][3]=D24;
	r.mat[2][0]=D31;r.mat[2][1]=D32;r.mat[2][2]=D33;r.mat[2][3]=D34;
	r.mat[3][0]=D41;r.mat[3][1]=D42;r.mat[3][2]=D43;r.mat[3][3]=D44;
	return r;
}
Point mlt(TMatrix a,Point b){
	return setPoint(	a.mat[0][0]*b.X+a.mat[0][1]*b.Y+a.mat[0][2]*b.Z+a.mat[0][3],
						a.mat[1][0]*b.X+a.mat[1][1]*b.Y+a.mat[1][2]*b.Z+a.mat[1][3],
						a.mat[2][0]*b.X+a.mat[2][1]*b.Y+a.mat[2][2]*b.Z+a.mat[2][3]);
}
Line mlt(TMatrix a,Line b){
	Line c=setLine(b.n); for(int i=0;i<c.n;i++) c.p[i]=mlt(a, b.p[i]);
	return c;
}
Poly mlt(TMatrix a,Poly b){
	Poly c=setPoly(b.n);
	for(int i=0;i<c.n;i++) c.p[i]=mlt(a,b.p[i]);
	return c;
}
TMatrix mlt(TMatrix a,TMatrix b){
	TMatrix c = setTMatrix();
	for(int i=0;i<4;i++)for(int j=0 ;j<4;j++){
		c.mat[i][j]=0;
		for(int k=0;k<4;k++) c.mat[i][j] += a.mat[i][k]*b.mat[k][j];
	}
	return c;

}
TMatrix scale(double scale_x, double scale_y, double scale_z)
{
	TMatrix m=setTMatrix();
	m.mat[0][0]=scale_x; m.mat[1][1]=scale_y; m.mat[2][2]=scale_z; 
	return m;
}
TMatrix scale(Point P){ return scale(P.X, P.Y, P.Z);}
TMatrix scale(double S){ return scale(S, S, S);}
TMatrix mlt(TMatrix a,double S){return mlt(a,scale(S));}
TMatrix mlt(double S,TMatrix a){return mlt(scale(S),a);}
TMatrix perspect(double d){
	TMatrix m=setTMatrix();
	m.mat[2][3]=-d; m.mat[3][2]=-1/d; return m;
}
TMatrix rot_x(double sn, double cs){ //X𒆐Sɉ]
	TMatrix m=setTMatrix();
	m.mat[1][1]=cs; m.mat[1][2]=-sn; m.mat[2][1]=sn; m.mat[2][2]=cs; 
	return m;
}
TMatrix rot_y(double sn, double cs){ //Y𒆐Sɉ]
	TMatrix m=setTMatrix();
	m.mat[0][0]=cs; m.mat[0][2]=sn; m.mat[2][0]=-sn; m.mat[2][2]=cs; 
	return m;
}
TMatrix rot_z(double sn, double cs){ //Z𒆐Sɉ]
	TMatrix m=setTMatrix();
	m.mat[0][0]=cs; m.mat[0][1]=-sn; m.mat[1][0]=sn; m.mat[1][1]=cs; 
	return m;
}
TMatrix rot_x(double r){ //X𒆐Sɉ]
	double PIR=PI/180; return rot_x(sin(r*PIR),cos(r*PIR));
}
TMatrix rot_y(double r){ //Y𒆐Sɉ]
	double PIR=PI/180; return rot_y(sin(r*PIR),cos(r*PIR));
}
TMatrix rot_z(double r){ //Z𒆐Sɉ]
	double PIR=PI/180; return rot_z(sin(r*PIR),cos(r*PIR));
}
TMatrix rotate(Point a, double sn, double cs){ //]ϊ
	Point P=setPoint(a.X, a.Y,0), axy=unit(P), axz=mlt(rot_z(-axy.Y,axy.X),unit(a));
	TMatrix M1=mlt(rot_z(axy.Y, axy.X),rot_y(-axz.Z,axz.X));
	TMatrix M2=mlt(rot_x(sn,cs), rot_y(axz.Z,axz.X));
	M2=mlt(M2,rot_z(-axy.Y, axy.X));
	return mlt(M1,M2);
	//return rot_z(axy.Y, axy.X)*rot_y(-axz.Z,axz.X)*rot_x(sn,cs)
	//			*rot_y(axz.Z,axz.X)*rot_z(-axy.Y, axy.X);
}
TMatrix rotate(double r) { return rot_z(r);}
TMatrix rotate(Point a, double r){
	double PIR=PI/180; return rotate(a,sin(r*PIR),cos(r*PIR));
}
TMatrix rotate(Point a, Point b){
	double sn=len(extmlt(unit(a) , unit(b)));
	if(sn !=0) return rotate(unit(extmlt(a,b)),sn, mlt(unit(a),unit(b)));
	return setTMatrix();
}
TMatrix rotate(Point n){ //xNgɉ]
	Point   P  = setPoint(1,0,0),ss = extmlt(P,unit(n)); if(len(ss)==0) ss= setPoint(0,0,1);
	Point   s  = unit(ss);
	TMatrix t1 = rot_x(-s.Y,s.Z), t3 = rot_x(s.Y,s.Z);
	Point   m  = unit(mlt(t1,n));
	TMatrix t2 = rot_z(m.Y, m.X);
	return  mlt(mlt(t3,t2),t1);
}
TMatrix move(double x, double y, double z){
	TMatrix m=setTMatrix();
	m.mat[0][3]=x; m.mat[1][3]=y; m.mat[2][3]=z;
	return m;
}
TMatrix move(Point P) { return move(P.X, P.Y, P.Z); }

TMatrix trans(TMatrix a){
	TMatrix c=setTMatrix();
	for(int i=0; i<4; i++)
		for(int j=0; j<4; j++) c.mat[i][j]=a.mat[j][i];
	return c;
}
TMatrix inverse(TMatrix a)
{
	double d=0;
	for(int i=0; i<3; i++)
		d = d + a.mat[0][i]*a.mat[1][(i+1)%3]*a.mat[2][(i+2) % 3]
				- a.mat[0][i]*a.mat[1][(i+2)%3]*a.mat[2][(i+1) % 3];
	TMatrix b=setTMatrix();
	if(d != 0)
		for(int i=0; i<3; i++)
			for(int j=0; j<3; j++)
				b.mat[i][j]=(a.mat[(j+1)%3][(i+1)%3]*a.mat[(j+2)%3][ (i+2)%3]
							-a.mat[(j+1)%3][(i+2)%3]*a.mat[(j+2)%3][ (i+1)%3])/d;
	for(int i=0; i<3; i++) b.mat[i][3]=-a.mat[i][3];
	return b;
}
//----̃fp----------------------------
#define MAXPOLY 50
typedef struct{
	int n; Poly p[MAXPOLY];
} Surface;
Surface setSurface(int n)   { Surface S; S.n=n; return S;}
Surface setSurface(Poly a)  { Surface S; S.n=1; S.p[0]=setPoly(a);return S;}
Surface setSurface(Surface a) {
	Surface S; S.n=a.n;
	for(int i=0;i<a.n; i++) S.p[i]=a.p[i];
	return S;
}
Surface mlt(TMatrix a, Surface b){
	Surface c=setSurface(b.n); 
	for(int i=0; i<c.n;i++) c.p[i]=mlt(a, b.p[i]);
	return c;
}
typedef struct{	Point o,d; } Ray;
Ray setRay(Point O, Point D){Ray R; R.o=O;R. d=D;return R;}
typedef struct{ Point o; double r;} Ball;
Ball setBall(Point O, double R){Ball B; B.o=O;B.r=R; return B;}
Ball setBall(Point O){Ball B; B.o=O;B.r=0;return B;}
Ball setBall(){Ball B; B.o=setPoint(0,0,0);B.r=0;return B;}
double hit(Ball B, Ray VR, Point *P, Point *N)
{
	double ds=mlt(VR.d,sub(VR.o,B.o));
	double d2=ds*ds-mlt(sub(VR.o,B.o),sub(VR.o,B.o)) + B.r*B.r;
	if(d2<0) return 1E+8F;
	double t= -ds - sqrt(d2);
	//if(t<0.5) t= -ds + Math.Sqrt(d2);
	*P=add(VR.o, mlt(t ,VR.d)); *N=unit(sub(*P,B.o));
	return t;
}
double hitV(Ball B, Ray VR, Point *P, Point *N)
{
	 double ds=mlt(VR.d, sub(VR.o, B.o));
	 double d2=ds*ds-mlt(sub(VR.o, B.o), sub(VR.o,B.o))+B.r*B.r;
	 if(d2<0) return 1E+8F;
	 return ( -ds - sqrt(d2));
}
typedef struct{ int n; Poly p; Point nv;} Wall;
Wall setWall(Poly pi){
	Wall W;
	W.p=setPoly(pi); W.n=W.p.n;
	W.nv=unit(extmlt(sub(W.p.p[0],W.p.p[2]), sub(W.p.p[1],W.p.p[3])));
	return W;
}
double hit(Wall W, Ray VR,Point*P, Point*N)
{
	double t=mlt(W.nv, sub(W.p.p[1], VR.o))/mlt(W.nv, VR.d);  //
	if(t<=0) return 1E+8F;
	*P=add(VR.o, mlt(t, VR.d)); *N=W.nv;
	for(int i=0; i<W.n-1; i++)
		if(mlt(*N,(extmlt(sub(W.p.p[i+1],W.p.p[i]),sub(*P,W.p.p[i]))))<0)return 1E+8F;
	return t;
}
//----̃fpI----------------------------
